#version 120
#extension GL_EXT_geometry_shader4 : enable

uniform sampler2D data;
uniform sampler2D xchannel;
uniform sampler2D ychannel;
uniform float size;

varying vec2 ex_pos;
varying float ex_color;

void main(void)
{
	//increment variable
	int i;

	//Pass-thru!
//	for (i=0; i < gl_VerticesIn; i++) {
//		gl_Position = gl_PositionIn[i];
//		EmitVertex();
//	}
//	EndPrimitive();
	float cx;
	float cy;
	
	//New piece of geometry!
	for (i=0; i < gl_VerticesIn; i++) {
		vec2 pos = gl_PositionIn[i].xy;
		ex_pos = pos;
		
		cx = texture2D(xchannel, (pos.xy+1.0)/2.0 ).r-0.5;
		cy = texture2D(ychannel, (pos.xy+1.0)/2.0 ).r-0.5;
		
		//cx = 0.1;
		//cy = 0.2;
		///ACHTUNG:::::: keine verschachtelten aufrufen von z.b. normalize(vec2(irgendwas veränderbares)) das geht nicht!!!!!!
		vec2 m = vec2(cx,cy);
		
		vec2 dir = normalize(m);
		vec2 norm = vec2(-dir.y, dir.x);
		
		float side = 0.005*size; 
		float peak = 0.01*size;
		
		//gl_Position.xy = vec2(pos.x + side, pos.y - peak);
		gl_Position.xy = pos - dir * peak + norm * side;
		ex_color = texture2D(data , (pos.xy + 1.0)/2.0).r;		
		
		EmitVertex();
		
		//gl_Position.xy = vec2(pos.x, pos.y + peak);
		gl_Position.xy = pos + dir * peak;
		EmitVertex();
		
		//gl_Position.xy = vec2(pos.x - side, pos.y - peak);
		gl_Position.xy = pos - dir * peak - norm * side;
		EmitVertex();
	}
	EndPrimitive();
}
